<?php

namespace App\Filament\Exports;

use App\Models\VehicleEntry;
use Filament\Actions\Exports\ExportColumn;
use Filament\Actions\Exports\Exporter;
use Filament\Actions\Exports\Models\Export;

class VehicleEntryExporter extends Exporter
{
    protected static ?string $model = VehicleEntry::class;

    public static function getColumns(): array
    {
        static $rowNumber = 0;
        return [
            ExportColumn::make('no')
                ->label('NO')
                ->state(function ($record) use (&$rowNumber) {
                    // Increment and return the row number
                    return ++$rowNumber;
                }),
            ExportColumn::make('plant.name')
            ->label('PLANT'),
            ExportColumn::make('boom_opened')
            ->label('BOOM OPENED'),
            ExportColumn::make('vehicle_number')
            ->label('VEHICLE NUMBER'),
            ExportColumn::make('entry_time')
            ->label('ENTRY TIME'),
            ExportColumn::make('exit_time')
            ->label('EXIT TIME'),
            ExportColumn::make('duration')
            ->label('DURATION'),
            ExportColumn::make('type')
            ->label('TYPE'),
            ExportColumn::make('created_at')
            ->label('CREATED AT'),
            ExportColumn::make('updated_at')
            ->label('UPDATED AT'),
            ExportColumn::make('created_by')
            ->label('CREATED BY'),
            ExportColumn::make('updated_by')
            ->label('UPDATED BY'),
            ExportColumn::make('deleted_at')
            ->label('DELETED AT')
            ->enabledByDefault(false),

        ];
    }

    public static function getCompletedNotificationBody(Export $export): string
    {
        $body = 'Your vehicle entry export has completed and ' . number_format($export->successful_rows) . ' ' . str('row')->plural($export->successful_rows) . ' exported.';

        if ($failedRowsCount = $export->getFailedRowsCount()) {
            $body .= ' ' . number_format($failedRowsCount) . ' ' . str('row')->plural($failedRowsCount) . ' failed to export.';
        }

        return $body;
    }
}
